# TP 24 : Statistiques
# BCPST1B 2023-2024
# Lycée Hoche, Versailles
# L.-C. LEFÈVRE

# Pyzo : exécuter une première fois le fichier avec "démarrer le script" ("run as script")
# et ne pas tenir compte des éventuelles erreurs

#%% démarrage

import numpy as np
import matplotlib.pyplot as plt
import pandas as pd

tips = pd.read_csv("tips.csv")
print(tips.info())

#%% stop ici
# ne pas exécuter, ou ne pas tenir compte de l'erreur

if __name__ == "__main__":
    raise RuntimeError("Exécuter les cellules")

####
# exploration du fichier

#%% affichage
print(tips)

#%% une colonne seule
print(tips["total_bill"])

#%% conversion en liste habituelle
print(tips["total_bill"].to_list())

#%% statistiques
tips["total_bill"].describe()

####
# fonctions à écrire

#%%

def maximum(L):
    ...

# test
print(maximum(tips["total_bill"].to_list()))

#%%

def minimum(L):
    ...

# test
print(minimum(tips["total_bill"].to_list()))

#%%

def moyenne(L):
    ...

# test
print(moyenne(tips["total_bill"].to_list()))

#%%

def variance(L):
    ...

def ecarttype(L):
    ...

# test
print(variance(tips["total_bill"].to_list()))
print(ecarttype(tips["total_bill"].to_list()))

#%%

def classes_entieres(L, b):
    ...

# test : les valeurs de L sont inférieures à 51
L = tips["total_bill"].to_list()
C = classes_entieres(L, 51)
print(C)

#%%

def cumul(C):
    ...

# test
L = tips["total_bill"].to_list()
C = classes_entieres(L, 51)
print(cumul(C))

#%%

def mediane(C):
    ...
    
# test
L = tips["total_bill"].to_list()
C = classes_entieres(L, 51)
print(mediane(C))

#%%

def quantile(C, p):
    ...

def quartile1(C):
    ...

def quartile3(C):
    ...
    
# test
L = tips["total_bill"].to_list()
C = classes_entieres(L, 51)
print(quartile1(C))
print(quartile3(C))
    
####
# représentations graphiques : exécuter simplement les cellules et observer
# on fabrique d'abord la bonne série ou le bon tableau, qu'on affiche
# puis on trace

#%% diagramme en barres : effectif
t = tips.groupby("sex").size()
print(t)
t.plot.bar()
plt.show()

#%%
# un autre
t = tips.groupby("day").size()
print(t)
t.plot.bar()
plt.show()

#%%
# groupés, barres côtes à côte
t = pd.crosstab(tips["sex"], tips["smoker"])
print(t)
t.plot.bar()
plt.show()

#%%
# groupés, barres empilées
t = pd.crosstab(tips["sex"], tips["smoker"])
print(t)
t.plot.bar(stacked=True)
plt.show()

#%%
# un autre
t = pd.crosstab(tips["day"], tips["time"])
print(t)
t.plot.bar(stacked=True)
plt.show()

#%% diagramme circulaire
t = tips.groupby("day").size()
print(t)
t.plot.pie()
plt.show()

#%%
# groupés
t = pd.crosstab(tips["smoker"], tips["day"])
print(t)
t.plot.pie(subplots=True)
plt.show()

#%% boite à moustaches
# cette syntaxe s'applique directement à une série statistique
# variante : tips.plot.box(column="total_bill")
tips["total_bill"].plot.box()
plt.show()

#%%
# groupés
tips.plot.box(column="total_bill", by="sex", subplots=False)
plt.show()

#%%
# encore
tips.plot.box(column="total_bill", by="day", subplots=False)
plt.show()

#%% histogramme
# idem, directement sur une série ; variante tips.plot.hist(column="total_bill")
tips["total_bill"].plot.hist()
plt.show()

#%%
# varier la finesse
tips["total_bill"].plot.hist(bins=5)
plt.show()

#%%
# ou encore
tips["total_bill"].plot.hist(bins=20)
plt.show()

#%%
# groupés
tips.plot.hist(column="total_bill", by="sex", subplots=True)
plt.show()

#%% effectif cumulés
tips.plot.hist(column="total_bill", bins=20, cumulative=True)
plt.show()

#%% nuage de points
tips.plot.scatter("total_bill", "tip")
plt.show()
